=== debian/changelog ===
merlin-agent (2.4.2-0kali1) kali-dev; urgency=medium

  * New upstream version 2.4.2
  * Use the Debian package golang-github-lucas-clemente-quic-go-dev
  * Use default golang-go version
  * Embed a more recent version of golang-refraction-networking-utls-dev
  * Add missing build-deps

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 21 Mar 2025 14:33:59 +0100

merlin-agent (1.6.5-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 24 Oct 2023 10:43:17 +0200
