=== debian/control ===
Source: merlin-agent
Priority: optional
Section: golang
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-go,
	       golang-github-armon-go-socks5-dev,
	       golang-github-cloudflare-circl-dev,
	       golang-github-cretz-gopaque-dev,
               golang-github-fatih-color-dev,
               golang-github-google-shlex-dev,
	       golang-github-go-jose-go-jose.v3-dev,
	       golang-github-lucas-clemente-quic-go-dev,
	       golang-github-ne0nd0g-merlin-dev,
	       golang-github-ne0nd0g-merlin-message-dev,
	       golang-github-satori-go.uuid-dev,
	       golang-go.dedis-kyber-dev,
	       golang-golang-x-crypto-dev,
	       golang-gopkg-square-go-jose.v2-dev,
#	       golang-refraction-networking-utls-dev
Standards-Version: 4.6.2
Vcs-Browser: https://gitlab.com/kalilinux/packages/merlin-agent
Vcs-Git: https://gitlab.com/kalilinux/packages/merlin-agent.git
Homepage: https://github.com/Ne0nd0g/merlin-agent
Testsuite: autopkgtest-pkg-go
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/Ne0nd0g/merlin-agent

Package: merlin-agent
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Cross-platform post-exploitation HTTP/2 Command & Control agent
 This package contains the Agent code for Merlin post-exploitation command and
 control framework.
