=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_after_dh_auto_configure:
	rm -rf $(CURDIR)/_build/src/github.com/marten-seemann
	rm -rf $(CURDIR)/_build/src/github.com/refraction-networking
	cp -r $(CURDIR)/debian/vendor/* $(CURDIR)/_build/src/

override_dh_auto_install:
	dh_auto_install -- --no-source
